#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct foto
{
	char* imePrezime;
	int dani;
	char* pol;
	int starost;
	struct foto* next;
} foto;

#define novi(x) x = (foto*)malloc(sizeof(foto))

void dodaj(foto** p, char* a, int b, char* c, int d)
{
	foto *res, *pos, *tmp;
	res = *p;
	novi(tmp);
	if(!tmp)
	{
		printf("Greska pri alokaciji\n");
		exit(0);
	}
	strtok(a,"\n");
	strtok(c,"\n");
	tmp->imePrezime = (char*)malloc(strlen(a) + 1);
	tmp->pol = (char*)malloc(strlen(c) + 1);
	strcpy(tmp->imePrezime, a);
	strcpy(tmp->pol,c);
	tmp->dani = b;
	tmp->starost = d;	
	tmp->next = NULL;
	if(res == NULL)
		res = tmp;
	else
	{
		pos = res;
		while(pos->next)
			pos = pos->next;
		pos->next = tmp;
	}
	*p = res;
}

foto* form_list(FILE* f)
{
	foto* p = NULL;
	char a[50], c[50];
	int b,d;
	while(1)
	{
		fgets(a,50,f);
		fscanf(f,"%d",&b);
		fgetc(f);
		fgets(c,50,f);
		fscanf(f,"%d",&d);
		fgetc(f);
		if(b > 30)
			break;
		else 
			dodaj(&p,a,b,c,d);
	}
	return p;
}

void ispis(foto *p)
{
	while(p)
	{
		printf("%s\t%d\t%s\t%d\n", p->imePrezime, p->dani, p->pol, p->starost);
		p = p->next;
	}
}


void ubaci(foto** p, char* ime, char* pol, int dani, int starost)
{
	foto *res, *tmp, *pos;
	res = *p;
	novi(tmp);
	if(!tmp)
	{
		printf("Greska pri alokaciji\n");
		exit(0);
	}
	tmp->imePrezime = (char*)malloc(strlen(ime) + 1);
	tmp->pol = (char*)malloc(strlen(pol) + 1);
	strcpy(tmp->imePrezime, ime);
	strcpy(tmp->pol,pol);
	tmp->dani = dani;
	tmp->starost = starost;
	tmp->next = NULL;
	pos = NULL;
	if(dani <= (*p)->dani)
	{
		tmp->next = (*p);
		(*p) = tmp;
	}
	else
	{
		res = *p;
		while(res)
		{
			if(dani <= res->dani)
			{
					pos->next = tmp;
					tmp->next = res;
			}
			pos = res;
			res = res->next;
		}
	}

}

foto* ucitaj_postu(foto** p)
{
	char ime[50], pol[50];
	int dani, starost;
	int i;
	for(i = 0; i < 5; i++)
	{		
		gets(ime);
		scanf("%d",&dani);
		getchar();
		gets(pol);
		scanf("%d",&starost);
		getchar();
		ubaci(p,ime,pol,dani,starost);
	}
	return *p;
	
}

float procenti(foto* p)
{
	float u = 0,z = 0;
	foto *res;
	res = p;
	while(res)
	{
		if(!strcmp(res->pol,"ZENSKI"))
			z++;
		res = res->next;
	}	
	res = p;
	while(res)
	{
			u++;
		res = res->next;
	}	
	return ((z/u)*100);
}

int main(int argc, char** argv)
{
	foto *p;
	FILE* f;
	f = fopen(argv[1], "r");
	if(!f)
	{
		printf("greska sa fajlom\n");
		exit(0);
	}
	p = form_list(f);
	ispis(p);
	printf("\n\n");

	p = ucitaj_postu(&p);
	ispis(p);
	printf("%f procenata\n",procenti(p));
}	





















